
Foreman - Bug #960

User without admin rights is not able to delete reports

06/06/2011 04:32 PM - Marcello de Sousa

Status: Resolved   

Priority: Normal   

Assignee:    

Category: Users, Roles and Permissions   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

A user with rights to "Edit Host" is able to delete the host but doesn't seem to have rights to delete the reports ... Deleting a host with

that user will slightly break the DB giving you a 500 when you generate reports with the "orphan" host ID.

PS.: I've tested this with the latest stable (0.2) and noticed the "last login" info for the user without admin rights is also not updated.

PS2.: "Nice to have" (not a "must"): It would be nicer if foreman would not crash with the orphan ID, but inform you about that (at the

error msg or at the specific report "row" self).

Related issues:

Related to Foreman - Bug #1064: "last login" info for a user without admin ri... Closed 07/24/2011

Related to Foreman - Feature #1067: Expose error messages in the web GUI Closed 07/24/2011

Related to Foreman - Bug #1137: Host was deleted but facts are not gone. Closed 08/30/2011

History

#1 - 06/07/2011 03:31 AM - Ohad Levy

- Target version changed from 0.3 to 0.4

#2 - 07/17/2011 10:58 AM - Ohad Levy

can you please see if the following patch solves your problem?

regarding the other topics, please open a bug for each issue... thanks!

diff --git a/app/models/report.rb b/app/models/report.rb

index e53e344..e6e14da 100644

--- a/app/models/report.rb

+++ b/app/models/report.rb

@@ -292,7 +292,11 @@ class Report < ActiveRecord::Base

     # Anyone can create a report

     return true if operation == "create" 

-    return true if operation == "destroy" and User.current.allowed_to?(:destroy_reports)

+    user = User.current

+    if operation == "destroy" 

+      return true if user.allowed_to?(:destroy_reports)

+      return true if user.allowed_to?(:destroy_hosts) and (user.filtering? and Host.my_hosts(user).include?(h

ost))

+    end

     errors.add_to_base "You do not have permission to #{operation} this report" 

     false

#3 - 07/24/2011 03:09 AM - Ohad Levy

- Status changed from New to Feedback

- Assignee changed from Ohad Levy to Marcello de Sousa
did you have time to try the above patch?

#4 - 07/24/2011 03:33 PM - Marcello de Sousa

Just tested it and it works!

#5 - 07/24/2011 04:04 PM - Marcello de Sousa

Sorry. I think I took some conclusions a bit too fast... I just got an error. Will test it more extensively and let you know.

#6 - 08/09/2011 05:44 AM - Marcello de Sousa

I could not get this to work. Is it possible for someone else to test it ?

#7 - 08/14/2011 10:34 AM - Ohad Levy

- Subject changed from User without admin rights is not able to detele reports to User without admin rights is not able to delete reports

#8 - 09/05/2011 06:33 PM - Marcello de Sousa

- Assignee changed from Marcello de Sousa to Ohad Levy

I've tested this patch above again with the latest develop and I can confirm it is not working.

When I delete a host without admin rights, the host is removed from the DB but the reports stay there with "orphan" host IDs and it breaks the UI

reports screen with the error :

host_reports_url failed to generate from {:action=>"index", :controller=>"reports"} - you may have ambiguous r

outes, or you may need to supply additional parameters for this route. content_url has the following required 

parameters: ["hosts", :host_id, "reports"] - are they all satisfied? ActionView::TemplateError , 

(eval):17:in `host_reports_path' 

app/views/reports/_list.html.erb:19 

app/views/reports/_list.html.erb:16:in `each' 

app/views/reports/_list.html.erb:16 

app/views/reports/index.html.erb:3

#9 - 09/27/2011 02:12 PM - Ohad Levy

- Target version deleted (0.4)

#10 - 01/03/2013 11:52 AM - Benjamin Papillon

- Status changed from Feedback to Assigned

#11 - 12/16/2013 10:47 AM - Anonymous

- Description updated

I think this is fixed. When the destroy_reports permission is assigned, users can destroy/delete hosts without problems in 1.3.1.

#12 - 03/31/2014 08:50 AM - Dominic Cleal

- Status changed from Assigned to Feedback

- Assignee deleted (Ohad Levy)

Verified in Foreman 1.5 too, associated reports are getting destroyed even when the user only has the destroy_hosts permission and no report

permissions.

#13 - 08/06/2014 04:37 AM - Dominic Cleal

- Status changed from Feedback to Resolved
